package de.hft.stuttgart.citydoctor2.healer.genetic;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import de.hft.stuttgart.citydoctor2.check.HealingMethod;
import de.hft.stuttgart.citydoctor2.healer.HealingMethodPrototype;
import de.hft.stuttgart.citydoctor2.healer.HealingPlan;

public class RandomHeuristic implements Heuristic<HealingPlan> {
	
	private List<HealingMethodPrototype> availableHealingMethods;
	
	public RandomHeuristic(List<HealingMethodPrototype> availableHealingMethods) {
		this.availableHealingMethods = availableHealingMethods;
	}

	@Override
	public HealingPlan generate() {
		List<HealingMethod> methods = new ArrayList<>();
		for (HealingMethodPrototype proto : availableHealingMethods) {
			methods.add(proto.createMethod());
		}
		Collections.shuffle(methods);
		HealingPlan plan = new HealingPlan();
		plan.getHealingMethods().addAll(methods);
		System.out.println("Generated: " + plan);
		return plan;
	}

}
